package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.model.board.MesWorkOrderBoardReqModel;
import cn.estsh.i3plus.ext.mes.pojo.model.board.MesWorkOrderBoardResModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.i3plus.pojo.mes.model.MesWorkOrderModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesProductAccountModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesProductAccountResModel;
import cn.estsh.i3plus.pojo.model.wms.WmsProductModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @CreateDate 2024/04/16
 * @Author mingliang.li
 */
public interface IMesWorkOrderService extends IBaseMesService<MesWorkOrder> {
    @ApiOperation("查询生产版本")
    ListPager<MesProductVersion> queryMesProductVersionByPager(MesProductVersion mesProductVersion, Pager pager);

    @ApiOperation("工单导入")
    void saveMesWorkOrderExcel(List<MesWorkOrder> mesWorkOrderList);

    @ApiOperation(value = "生产报工")
    void doProductReport(MesWorkOrder mesWorkOrder);

    @ApiOperation(value = "生产报工(武汉)")
    void doProductReportExt(MesWorkOrder mesWorkOrder);

    @ApiOperation("非排序工单导入前删除")
    void doCloseUnSortOrder(String organizeCode,String userName);

    @ApiOperation("汇总工单给SAP")
    List<MesWorkOrderModel> sumMesWorkOrderQtyToSap(String organizeCode);

    @ApiOperation("ccscTest")
    List<MesWorkOrder> queryMesWorkOrderProcessToSap(String organizeCode);

    @ApiOperation("查询工单信息")
    MesWorkOrder getMesWorkOrder(String workOrderNo,String organizeCode);

    @ApiOperation("反向冲销")
    void doReportWorkReversal(WmsProductModel model);

    @ApiOperation("重新打开")
    void doReopen(Long[] ids,String userName,String organizeCode);

    @ApiOperation("新增工单打印队列")
    void doSaveWorkOrderPrintQueue(MesWorkOrder workOrder);

    @ApiOperation("装配目视单补打")
    List<Map<String, Object>> doReprintWorkOrder(Long[] ids, String organizeCode, String userName);

    @ApiOperation("装配目视单预览")
    List<Map<String, Object>> doShowWorkOrderPrint(String partNo, String workCenterCode, String partProdGroupCode,
                                                   String carModelCode, String organizeCode, String userName);

    List<MesProductionRecord> getPreDayReportMesProductionRecord(String organizeCode , List<MesShift> mesShiftList, String  workCenterCode);

    List<MesProduceSn> getPreDayReportMesProduceSn(String organizeCode ,List<MesProductionRecord> mesProductionRecordList );

    List<MesWorkOrder> insertMesWorkOrder(List<MesProductionRecord> mesProductionRecordList,List<MesShift> mesShiftList,String organizeCode, String userName );

    void doPcnJobProductReport(List<MesProductionRecord> mesProductionRecordList,List<MesShift> mesShiftList,String organizeCode, String userName, MesWorkOrder mesWorkOrder);

    @ApiOperation("MES工单推送给WMS")
    void doSendMesWorkOrderToWms(String organizeCode,Integer pageSize,String userName);

    @ApiOperation(value = "BTO工单看板")
    List<MesWorkOrderBoardResModel> orderBoard(MesWorkOrderBoardReqModel workOrderBoardReqModel);

}
