package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderLogService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.BeanUtil;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderLog;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.hibernate.SQLQuery;
import org.hibernate.transform.Transformers;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Service
@Slf4j
public class MesWorkOrderLogService extends BaseMesService<MesWorkOrderLog> implements IMesWorkOrderLogService {
    @Autowired
    private EntityManager entityManager;
    @Override
    public void saveMesWorkOrderLog(MesWorkOrder mesWorkOrder, MesExtEnumUtil.WORK_ORDER_LOG_TYPE type, double qty) {
        MesWorkOrderLog workOrderLog = new MesWorkOrderLog();
        BeanUtils.copyProperties(mesWorkOrder, workOrderLog, "id");
        workOrderLog.setType(type.getValue());
        workOrderLog.setModifyQty(qty);
        baseRDao.insert(workOrderLog);
    }

    @Override
    public ListPager queryMesWorkOrderLogByPage(MesWorkOrderLog mesWorkOrderLog, Pager pager) {
        String org = mesWorkOrderLog.getOrganizeCode();
        String startTime = mesWorkOrderLog.getCreateDateTimeStart();
        String endTime = mesWorkOrderLog.getCreateDateTimeEnd();
        List<MesWorkOrderLog> mesWorkOrderLogList = new ArrayList<>();

        String commHql = " SELECT " +
                " wol.id as id," +
                " wol.organize_code as organizeCode," +
                " wol.create_date_time AS createDatetime, " +
                " wol.create_user AS createUser, " +
                " wol.modify_date_time AS  modifyDatetime, " +
                " wol.modify_user AS  modifyUser, " +
                " wol.work_order_no as workOrderNo," +
                " wol.work_order_type as workOrderType," +
                " wol.work_order_seq as workOrderSeq," +
                " wol.cust_part_no as custPartNo," +
                " wol.part_no as partNo," +
                " wol.part_name as partName," +
                " wol.type as type," +
                " wol.qty as qty,"+
                " wol.area_code as areaCode," +
                " wol.work_center_code as workCenterCode," +
                " wol.product_version as productVersion," +
                " wol.erp_work_center as erpWorkCenter," +
                " wol.work_order_status as workOrderStatus," +
                " wol.shift_code as shiftCode," +
                " wol.shift_name as shiftName," +
                " wol.order_flag as orderFlag," +
                " wol.wo_source as workOrderSource," +
                " wol.adjust_qty as adjustQty,"+
                " wol.modify_qty as modifyQty,"+
                " wol.remark as remark," +
                " wol.description as description "
                ;

        String sql = " from mes_work_order_log wol" +
                " where 1=1  " +
                " and wol.organize_code =:organizeCode " +
//                " and wol.work_order_type = '20'  " +
//                " and wol.adjust_qty > 0  " +
                " and wol.is_deleted ='2' " +
                " and wol.is_valid ='1' ";
        if (!StringUtil.isEmpty(startTime)) {
            sql += " and wol.modify_date_time >=:startTime ";
        }
        if (!StringUtil.isEmpty(endTime)) {
            sql += " and wol.modify_date_time <:endTime ";
        }

        if (!StringUtil.isEmpty(mesWorkOrderLog.getWorkOrderNo())) {
            sql += " and wol.work_order_no ='" + mesWorkOrderLog.getWorkOrderNo() + "' ";
        }
        if (!StringUtil.isEmpty(mesWorkOrderLog.getWorkCenterCode())) {
            sql += " and wol.work_center_code ='" + mesWorkOrderLog.getWorkCenterCode() + "' ";
        }
        if (!StringUtil.isEmpty(mesWorkOrderLog.getPartNo())) {
            sql += " and wol.part_no ='" + mesWorkOrderLog.getPartNo() + "' ";
        }
        if (!StringUtil.isEmpty(mesWorkOrderLog.getType())) {
            sql += " and wol.type ='" + mesWorkOrderLog.getType() + "' ";
        }else {
            sql += " and wol.type in ('30','40') ";
        }
        sql += "  ORDER BY wol.modify_date_time desc,work_order_no  ";

        Query queryObject = entityManager.createNativeQuery(commHql + sql);
        queryObject.setParameter("organizeCode", org);
        if (!StringUtil.isEmpty(startTime)) {
            queryObject.setParameter("startTime", startTime);
        }
        if (!StringUtil.isEmpty(endTime)) {
            queryObject.setParameter("endTime", endTime);
        }

         queryObject.unwrap(SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);

        List<HashMap<String, Object>> hashMaps = queryObject.getResultList();
        if (CollectionUtils.isEmpty(hashMaps)) {
            return new ListPager(mesWorkOrderLogList, pager);
        }
        pager = PagerHelper.getPager(pager, hashMaps.size());

        queryObject.setFirstResult(pager.getStartRow()).setMaxResults(pager.getPageSize());
        hashMaps = queryObject.getResultList();

        for (HashMap<String, Object> hashMap : hashMaps) {
            try {
                mesWorkOrderLogList.add((MesWorkOrderLog) BeanUtil.populateBean(hashMap, MesWorkOrderLog.class));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return new ListPager(mesWorkOrderLogList, pager);

    }

    @Override
    public List<MesWorkOrderLog> findMesWorkOrderLog(String workOrderNo, String organizeCode) {
        if(StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo,"workOrderNo",packBean);
        return baseRDao.findByHqlWhere(packBean);
    }
}
